(*
    Yawn - Boss mode management
    Copyright (c) 1995-2003 Alessandro Scotti
    http://www.walkofmind.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*)
unit BossTool;

interface

uses
  WinTypes, WinProcs;

function bossCheck: boolean;
procedure bossEnter( Wnd: HWnd; Caption: string; Icon: HIcon );
procedure bossLeave;

implementation

const
  OldCaption  : array[ 0..255 ] of char = '';
  OldIcon     : HIcon = 0;
  WndHandle   : HWnd = 0;

(*
    Activates boss mode
*)
procedure bossEnter( Wnd: HWnd; Caption: string; Icon: HIcon );
begin
  if( bossCheck ) then
    Exit;
  (* Save current caption and icon *)
  GetWindowText( Wnd, OldCaption, 255 );
  OldIcon := GetClassWord( Wnd, -14 );
  (* Set new caption and icon *)
  Caption := Caption + #0;
  SetWindowText( Wnd, @Caption[1] );
  if( Icon <> 0 ) then
    SetClassWord( Wnd, -14, Icon );
  (* Remember window handle *)
  WndHandle := Wnd;
end;

(*
    Terminates boss mode
*)
procedure bossLeave;
begin
  if( bossCheck ) then begin
    (* Restore original caption and text *)
    SetWindowText( WndHandle, OldCaption );
    SetClassWord( WndHandle, -14, OldIcon );
    (* Reset window handle *)
    WndHandle := 0;
  end;
end;

(*
    Returns TRUE if currently in boss mode,
    FALSE otherwise
*)
function bossCheck: boolean;
begin
  bossCheck := WndHandle <> 0;
end;

end.
